		GBLL DEBUG
		GBLL SAFETY

DEBUG		SETL {FALSE}

;BUILD		SETS "DEBUG"/"GBA"	(defined at cmdline)
;----------------------------------------------------------------------------
	INCLUDE gba_hw.h

YSCALE_EXTRA	EQU 0x03007B00
YSCALE_LOOKUP	EQU YSCALE_EXTRA+0x50
;?				EQU YSCALE_LOOKUP+0x200		; was 0x100

VDP_RAM			EQU 0x02040000-0x4000
EMU_RAM 		EQU VDP_RAM-0x400
STATEPTR		EQU EMU_RAM-0x100
EMUPALBUFF		EQU STATEPTR-272*2			;SMS palette buffer, also in GBA.h
SMSOAMBUFF	 	EQU EMUPALBUFF-0x180
OAM_BUFFER2 	EQU SMSOAMBUFF-0x400
OAM_BUFFER1 	EQU OAM_BUFFER2-0x400
TMAPBUFF		EQU OAM_BUFFER1-240
DIRTYTILES		EQU TMAPBUFF-512
MEMMAPTBL_		EQU DIRTYTILES-8*4
WRMEMTBL_		EQU MEMMAPTBL_-8*4
FREQTBL			EQU WRMEMTBL_-1024*2
PCMWAVSIZE		EQU 528
PCMWAV			EQU FREQTBL-PCMWAVSIZE*2
END_OF_EXRAM	EQU PCMWAV-0xF100			;-0xF100 room left for code.

CHR_DECODE		EQU AGB_VRAM+0x0400			;0x400
;EmptyTiles		EQU AGB_VRAM+0x4000
DMA0BUFF		EQU AGB_VRAM+0x5800
DEBUGSCREEN		EQU AGB_VRAM+0x3800

EMU_SRAM		EQU AGB_SRAM+0x4000

		;r0,r1,r2=temp regs
globalptr	RN r10	;@ =wram_globals* ptr
addy		RN r12	;@ keep this at r12 (scratch for APCS)
			;@ r13=SP
			;@ r14=LR
			;@ r15=PC
;----------------------------------------------------------------------------

;everything in wram_globals* areas:

 MAP 0,globalptr	;z80.s
z80_memmap_tbl_offset # -64*4
z80_memmap_tbl # 64*4
z80_opz # 256*4
z80_pzst # 256
z80_writemem_tbl # 8*4
z80_regs # 8*4
z80_regs2 # 8*4
z80_ix # 4
z80_iy # 4
z80_i # 1
z80_r # 1
z80_iff1 # 1
z80_iff2 # 1
z80_im # 1
z80_irq_pin # 1
z80_nmi_pin # 1
z80_old_nmi # 1
z80_out0 # 1
z80_temp1 # 1
z80_temp2 # 1
z80_temp3 # 1
z80_lastbank # 4
z80_nexttimeout # 4
z80_nexttimeout_ # 4
z80_oldcycles # 4
			;cpu.s (wram_globals1)
scanlinehook # 4
cyclesperscanline # 4
lastscanline # 4
			;gfx.s (wram_globals2)
fpsvalue # 4
AGBjoypad # 4
EMUjoypad # 4
windowtop # 16
scanline # 4
frame # 4

adjustblend # 1
twitch # 1
flicker # 1
keyb_on # 1

vramaddr # 4

vdpmode1 # 1
vdpmode2 # 1
nametable # 1
ctoffset # 1
pgoffset # 1
satoffset # 1
sproffset # 1
bdcolor # 1

vdpbuff # 1
vdptoggle # 1
vdpstat # 1
vdpctrl # 1
vdpctrlbuff # 1
vdpmode2_bak # 1
minpan # 1
maxpan # 1
ystart # 1		;6 scaled SMS 224 screen starts on this line
sprBank # 1
keyb_scroll # 1
 # 1 ;align
			;cart.s (wram_globals3)
rombase # 4
romnumber # 4
emuflags # 4

BGoffset1 # 4
BGoffset2 # 4
BGoffset3 # 4
biosbase # 4
BankMap0 # 1
BankMap1 # 1
BankMap2 # 1
BankMap3 # 1
BankMap4 # 4
cartflags # 1
config # 1
 # 2 ;align

;-----------------------------------------------------------cartflags
SRAM			EQU 0x02 ;save SRAM
;-----------------------------------------------------------emuflags
PALTIMING		EQU 1	;PAL timing =)
COUNTRY			EQU 2	;0=World 1=JAP
NOCPUHACK		EQU 4	;don't use JMP hack
;?				EQU 16
FOLLOWMEM       EQU 32  ;0=follow sprite, 1=follow mem

				;bits 8-15=scale type

UNSCALED_NOAUTO	EQU 0	;display types
UNSCALED_AUTO	EQU 1
SCALED			EQU 2
SCALED_SPRITES	EQU 3

				;bits 16-31=sprite follow val

;----------------------------------------------------------------------------

		END

